var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var plugin_exports = {};
__export(plugin_exports, {
  PluginWorkflowApproval: () => PluginWorkflowApproval,
  default: () => plugin_default
});
module.exports = __toCommonJS(plugin_exports);
var import_path = __toESM(require("path"));
var import_server = require("@nocobase/server");
var import_plugin_workflow = __toESM(require("@nocobase/plugin-workflow"));
var import_ApprovalTrigger = __toESM(require("./ApprovalTrigger"));
var import_ApprovalInstruction = __toESM(require("./ApprovalInstruction"));
var import_actions = require("./actions");
class PluginWorkflowApproval extends import_server.Plugin {
  workflow;
  afterAdd() {
  }
  beforeLoad() {
    this.app.on("afterLoadPlugin", (plugin) => {
      if (!(plugin instanceof import_plugin_workflow.default)) {
        return;
      }
      this.workflow = plugin;
      plugin.triggers.register("approval", new import_ApprovalTrigger.default(plugin));
      plugin.instructions.register("approval", new import_ApprovalInstruction.default(plugin));
    });
  }
  async load() {
    const { db } = this;
    db.addMigrations({
      namespace: "approval",
      directory: import_path.default.resolve(__dirname, "migrations"),
      context: {
        plugin: this
      }
    });
    await db.import({
      directory: import_path.default.resolve(__dirname, "collections")
    });
    (0, import_actions.init)(this);
    this.app.acl.allow("workflows", ["listApprovalFlows"], "loggedIn");
    this.app.acl.allow("approvals", "*", "loggedIn");
    this.app.acl.allow("approvalExecutions", ["get"], "loggedIn");
    this.app.acl.allow("approvalRecords", ["get", "list", "listCentralized", "submit"], "loggedIn");
  }
  async install(options) {
  }
  async afterEnable() {
  }
  async afterDisable() {
  }
  async remove() {
  }
}
var plugin_default = PluginWorkflowApproval;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PluginWorkflowApproval
});
